﻿/// <reference path="../../Resources/TypeDefinitions/knockout/knockout.d.ts"/>
/// <reference path="../../Resources/TypeDefinitions/jquery/jquery.d.ts"/>
/// <reference path="../../Resources/TypeDefinitions/inedojq/inedojq_frameddialog.d.ts"/>
/// <reference path="../../rubbish.ts"/>

var NpmPackageVersionPageViewModel = (function () {
    function NpmPackageVersionPageViewModel(input) {
        var _this = this;
        this.name = input.name;
        this.version = input.version;
        this.isLocal = input.downloadCount != null;
        this.downloadCount = input.downloadCount;
        this.deleteUrl = input.deleteUrl;
        this.downloadUrl = input.downloadUrl;
        this.publishedDate = input.publishedDate;
        this.pullUrl = input.pullUrl;
        this.npmHelpUrl = input.npmHelpUrl;

        var renderMarkdown = function (markdown) {
            var rubbish = window.marked;
            if (markdown)
                return rubbish(markdown);
            else
                return null;
        };

        this.isLoading = ko.observable(true);
        this.description = ko.observable(input.description);
        this.projectUrl = ko.observable(input.projectUrl);
        this.readme = ko.observable(renderMarkdown(input.readme));
        this.dependencies = ko.observable(input.dependencies || []);
        this.allVersions = ko.observable(input.allVersions || []);

        $.ajax({
            url: input.getAllDataUrl,
            type: 'POST',
            data: { feedId: input.feedId, name: this.name, version: this.version },
            success: function (data) {
                _this.description(data.description);
                _this.projectUrl(data.projectUrl);
                _this.readme(renderMarkdown(data.readme));
                _this.dependencies(data.dependencies);
                _this.allVersions(data.allVersions);
                _this.isLoading(false);
            }
        });
    }
    NpmPackageVersionPageViewModel.prototype.pullClick = function () {
        $.inedojq_frameddialog(this.pullUrl);
    };

    NpmPackageVersionPageViewModel.prototype.deleteClick = function () {
        $.inedojq_frameddialog(this.deleteUrl);
    };

    NpmPackageVersionPageViewModel.prototype.npmHelpClick = function () {
        $.inedojq_frameddialog(this.npmHelpUrl);
    };
    return NpmPackageVersionPageViewModel;
})();
